#include "stdutils.h"
#include "complex.h"
#include "matrix.h"
#include "fft.h"
#include "inout.h"
#include "func.h"

void
main(argc, argv)
int argc;
char **argv;

{
    char *input_file_name = (char *) AllocateString(256);
    char *output_file_name = (char *) AllocateString(256);
    int input_file_descriptor;
    int output_file_descriptor;
    int height;
    int width;
    int num_points;
    double *input_data;
    double **input_data_matrix;
    double *output_data;
    double **output_data_matrix;
    COMPLEX ***complex_input_data_matrix;
    COMPLEX ***complex_output_data_matrix;
    int row;
    int col;

    if(argc < 4) {
	(void) fprintf(stdout, 
	"Syntax: egdfts file height width\n");
	(void) fflush(stdout);
	(void) exit(0);
    }
    (void) sscanf(argv[1], "%s", input_file_name);
    (void) sscanf(argv[2], "%d", &height);
    (void) sscanf(argv[3], "%d", &width);
    (void) strcpy(output_file_name, input_file_name);
    (void) strcat(input_file_name, ".in");
    (void) strcat(output_file_name, ".out");
    output_file_descriptor = (int) creat(output_file_name, 0644);
/*
    input_file_descriptor = (int) open(input_file_name, O_RDONLY, 0);
    if((num_points = (int) lseek(input_file_descriptor, 0, SEEK_END)) ==
    (int) NIL) {
	(void) fprintf(stdout, "Error: File %s nonexistent.  Exit 1.\n",
	input_file_name);
	(void) fflush(stdout);
	(void) exit(1);
    }
    (void) lseek(input_file_descriptor, -(num_points), SEEK_END);
*/
num_points = height * width;
    input_data = (double *) RealCreateVector(num_points);
    input_data_matrix = (double **) RealCreateMatrix(height, width);
    complex_input_data_matrix = 
    (COMPLEX ***) ComplexCreateMatrix(height, width);
    output_data = (double *) RealCreateVector(num_points);
    output_data_matrix = (double **) RealCreateMatrix(height, width);
    complex_output_data_matrix = 
    (COMPLEX ***) ComplexCreateMatrix(height, width);
/*
    (void) ReadIn(input_file_descriptor, input_data, input_data_matrix,
    NOVERTICALNOHORIZONTALFLIP, height, width, num_points);
*/
for(row=0;row < height;row++){
for(col=0;col < width;col++){
input_data_matrix[row][col]=0.0;
}}
input_data_matrix[0][0]=1.0;
    (void) RealMatrixToComplexMatrix(complex_input_data_matrix, 
    input_data_matrix, height, width);
    (void) DFT2D(complex_output_data_matrix, 
    complex_input_data_matrix, height, width);
    (void) ComplexMatrixToRealVector(output_data, 
    complex_output_data_matrix, MAGNITUDE, height, width);
output_data[0]=0;
    (void) WriteOut(output_file_descriptor, NOVERTICALNOHORIZONTALFLIP, 8, 
    output_data, height, width, num_points, COEFF);
/*
    if((int) close(input_file_descriptor) == (int) NIL) {
	(void) fprintf(stdout, 
	"Error: Cannot close input file.  Exit 1.\n");
	(void) fflush(stdout);
	(void) exit(1);
    }
*/
    if((int) close(output_file_descriptor) == (int) NIL) {
	(void) fprintf(stdout, "Error: Cannot close output file.  Exit 1.\n");
	(void) fflush(stdout);
	(void) exit(1);
    }
    (void) RealFreeVector(input_data);
    (void) RealFreeMatrix(input_data_matrix, height);
    (void) ComplexFreeMatrix(complex_input_data_matrix, height, width);
    (void) RealFreeVector(output_data);
    (void) RealFreeMatrix(output_data_matrix, height);
    (void) ComplexFreeMatrix(complex_output_data_matrix, height, width);
    (void) free(input_file_name);
    (void) free(output_file_name);
    (void) exit(0);
}
