
/*******************************************************************************************/
/*                        C ROUTINES FOR THE STEERABLE PYRMAID
                   COPYRIGHT 1993, PERCEPTUAL COMPUTING GROUP, MEDIA LABORATORY
		           MASSACHUSSETTS INSTITUTE OF TECHNOLOGY

*/


#include <stdio.h>
#include <math.h>

void downsample2d();
void upsample2d();


/* returns a downsampled image of (xdim/xrate, ydim/yrate) */
/* from input image of (xdim, ydim) */

/* assume allocated memory for res */


void downsample2d (im1,res,xdim,ydim,xrate,yrate)
float	**im1;
float   **res;
int	xdim, ydim;
int	xrate, yrate;
{

  int           i, j;
 

  if (xrate==1 && yrate==1)  {
    printf("No downsampling ! xrate=yrate=1 \n ");
    exit(-1);
  }
 
  for (i=0; i<ydim/yrate; i++)
    for (j=0; j<xdim/xrate; j++)
      res[i][j] = im1[i*yrate][j*xrate];
 
}



/* output a upsampled image of (xdim*xrate, ydim*yrate) */
/* from input image of (xdim, ydim) */

void upsample2d (im1,res,xdim,ydim,xrate,yrate)
float	**im1;
float   **res;
int	xdim, ydim;
int	xrate, yrate;

{
  
  int           i, j;
  
  if (xrate==1 && yrate==1)  
    {
      printf("No upsampling  xrate=yrate=1 ");
      exit(-1);
    }
  
  for (i=0; i<ydim; i++)
    for (j=0; j<xdim; j++)
      res[i][j]=0;
  
  
  for (i=0; i<ydim; i++)
    for (j=0; j<xdim; j++)
      res[yrate*i][xrate*j]= im1[i][j]; 
  
}











