/*
*******************************************************************************
Author: 
	Alex Sherstinsky,
	Media Laboratory, 
	Building E15 Room 383,
	20 Ames Street, Cambridge, MA 02139,
	Massachusetts Institute Of Technology,
	77 Massachusetts Avenue,
	Cambridge, MA 02139
	Telephone: (617)253-0381 
	Electronic Mail Address: shers@media.mit.edu
Copyright 1993 Massachusetts Institute Of Technology
All rights reserved.
This program may not be distributed to other organizations without the 
permission of the author.  In no case may it be distributed outside the
United States and Canada.  This program is supplied "as is", without any
kind of warranty, and M.I.T. does not promise to support it in any way.
This program is not to be incorporated into a commercial product, or access
to it sold, without prior written agreement from the author.
*******************************************************************************
AlMa Library
*******************************************************************************
*/
/*
Useful constants.
*/

#define NIL 0xffffffff/*nil to be cast into any type*/
#define EPSILON 1.0e-11/*small positive real number*/
#define INFINITY 1.0e+11/*large positive real number*/
#define NEGHUGE 0x80000000/*largest negative integer*/
#define POSHUGE 0x7fffffff/*largest positive integer*/

/*
Useful functions.
*/

int SignInt();
double SignFloat();
int MinInt();
double MinFloat();
int MaxInt();
double MaxFloat();
void SwapInt();
void SwapFloat();
int AbsInt();
double AbsFloat();
int SquareInt();
double SquareFloat();
int FixFloat();
int Odd();
int Xor();
char * MidString();
char * AllocateString();
double Random();
int Factorial();
int Choose();
void ConstructChoiceTable();
void FindLegalChoices();
char * SafeMalloc();
