/*
*******************************************************************************
Author: 
	Alex Sherstinsky,
	Media Laboratory, 
	Building E15 Room 383,
	20 Ames Street, Cambridge, MA 02139,
	Massachusetts Institute Of Technology,
	77 Massachusetts Avenue,
	Cambridge, MA 02139
	Telephone: (617)253-0381 
	Electronic Mail Address: shers@media.mit.edu
Copyright 1993 Massachusetts Institute Of Technology
All rights reserved.
This program may not be distributed to other organizations without the 
permission of the author.  In no case may it be distributed outside the
United States and Canada.  This program is supplied "as is", without any
kind of warranty, and M.I.T. does not promise to support it in any way.
This program is not to be incorporated into a commercial product, or access
to it sold, without prior written agreement from the author.
*******************************************************************************
AlMa Library
*******************************************************************************
*/
/*
This module reads and writes data sequences.
*/

/*
Useful constants.
*/

#define VERTICALFLIP 1/*directive to flip input image vertically*/
#define HORIZONTALFLIP 0/*directive to flip input image horizontally*/
#define VERTICALHORIZONTALFLIP 2
/*directive to flip input image both vertically and horizontally*/
#define NOVERTICALNOHORIZONTALFLIP (int) NIL
/*directive to flip input image neither vertically nor horizontally*/
#define SIGNAL 0/*processed signal data style*/
#define COEFF 1/*transform coefficients data style*/
#define MAGCOEFF 2/*magnitude of transform coefficients data style*/
#define LOGMAGCOEFF 3/*log10 of magnitude of transform coefficients data style*/
#define MINGRAYVALUE 0/*min allowed gray scale value*/
#define MAXGRAYVALUE 255/*max allowed gray scale value*/
#define OPENPIPE 0/*directive to open pipe*/
#define CLOSEPIPE 1/*directive to close pipe*/
#define OPENCLOSEPIPE 2/*directive to open and then close pipe*/
#define NOOPENNOCLOSEPIPE (int) NIL/*directive to neither open nor close pipe*/
#define TYPIMAGEDIM 256/*height and width of typical image*/
#define DISPLAYSCRIPT "/v/users/shers/bin/rlemoviedispbw"
/*shell script for displaying raw image data; args: height, width, zoom, title*/

/*
Functions used.
*/

void ReadIn();
void WriteOut();
void DisplayRLE();
void FlipImage();
void ZoomImage();
void FloatToGraySignalVector();
void FloatToGrayCoeffVector();
void FloatToGrayMCVector();
void FloatToGrayLMCVector();
FILE * nshpopen();
int * nshpclose();
char * mynext();
char ** breakargs();
