/*
*******************************************************************************
Author: 
	Alex Sherstinsky,
	Media Laboratory, 
	Building E15 Room 383,
	20 Ames Street, Cambridge, MA 02139,
	Massachusetts Institute Of Technology,
	77 Massachusetts Avenue,
	Cambridge, MA 02139
	Telephone: (617)253-0381 
	Electronic Mail Address: shers@media.mit.edu
Copyright 1993 Massachusetts Institute Of Technology
All rights reserved.
This program may not be distributed to other organizations without the 
permission of the author.  In no case may it be distributed outside the
United States and Canada.  This program is supplied "as is", without any
kind of warranty, and M.I.T. does not promise to support it in any way.
This program is not to be incorporated into a commercial product, or access
to it sold, without prior written agreement from the author.
*******************************************************************************
AlMa Library
*******************************************************************************
*/
/*
This module manipulates vectors and matrices of real-valued and complex-valued 
double precision floating point numbers.
*/

/*
Useful constants.
*/

#define MAGNITUDE 0
#define REALPART 1

/*
Functions used.
*/

void RealClearVector();
double * RealCreateVector();
void RealFreeVector();
void RealCopyVector();
void RealScaleVector();
void RealInitVector();
void RealAddVectors();
void RealSubtractVectors();
void RealInnerProduct();
void RealAccumulateVector();
void RealHeapSortVector();
void BuildHeap();
void Heapify();
void RealClearMatrix();
double ** RealCreateMatrix();
void RealFreeMatrix();
void RealCopyMatrix();
void RealScaleMatrix();
void RealInitMatrix();
void RealAddMatrices();
void RealSubtractMatrices();
void RealMatrixMultVector();
void RealTranspose();
void RealTrace();
void RealAccumulateMatrix();
void RealMatrixInnerProduct();
void RealMatrixMultMatrix();
void RealGaussElimPartPiv();
void RealPartialPivot();
void RealInvertMatrix();
void RealGramSchmidt();
void RealOrthogVector();
void RealOrthoNormVector();
void Eigen();
void SVD();
void svdcmp_nric();
void RealDeterminant();
void RealShowVector();
void RealShowMatrix();
void ComplexClearVector();
COMPLEX ** ComplexCreateVector();
void ComplexFreeVector();
void ComplexCopyVector();
void ComplexScaleVector();
void ComplexInitVector();
void ComplexAddVectors();
void ComplexSubtractVectors();
void ComplexConjugateVector();
void ComplexInnerProduct();
void ComplexConjugateInnerProduct();
void ComplexAccumulateVector();
void ComplexClearMatrix();
COMPLEX *** ComplexCreateMatrix();
void ComplexFreeMatrix();
void ComplexCopyMatrix();
void ComplexScaleMatrix();
void ComplexInitMatrix();
void ComplexAddMatrices();
void ComplexSubtractMatrices();
void ComplexConjugateMatrix();
void ComplexMatrixMultVector();
void ComplexTranspose();
void ComplexConjugateTranspose();
void ComplexTrace();
void ComplexAccumulateMatrix();
void ComplexMatrixInnerProduct();
void ComplexMatrixMultMatrix();
void ComplexGaussElimPartPiv();
void ComplexPartialPivot();
void ComplexInvertMatrix();
void ComplexGramSchmidt();
void ComplexOrthogVector();
void ComplexOrthoNormVector();
void ComplexDeterminant();
void ComplexShowVector();
void ComplexShowMatrix();
void RealVectorToComplexVector();
void ComplexVectorToRealVector();
void RealMatrixToComplexMatrix();
void ComplexMatrixToRealMatrix();
void RealVectorToRealMatrix();
void RealVectorToComplexMatrix();
void RealMatrixToRealVector();
void RealMatrixToComplexVector();
void ComplexVectorToRealMatrix();
void ComplexVectorToComplexMatrix();
void ComplexMatrixToRealVector();
void ComplexMatrixToComplexVector();
