/*
*******************************************************************************
Author: 
	Alex Sherstinsky,
	Media Laboratory, 
	Building E15 Room 383,
	20 Ames Street, Cambridge, MA 02139,
	Massachusetts Institute Of Technology,
	77 Massachusetts Avenue,
	Cambridge, MA 02139
	Telephone: (617)253-0381 
	Electronic Mail Address: shers@media.mit.edu
Copyright 1993 Massachusetts Institute Of Technology
All rights reserved.
This program may not be distributed to other organizations without the 
permission of the author.  In no case may it be distributed outside the
United States and Canada.  This program is supplied "as is", without any
kind of warranty, and M.I.T. does not promise to support it in any way.
This program is not to be incorporated into a commercial product, or access
to it sold, without prior written agreement from the author.
*******************************************************************************
AlMa Library
*******************************************************************************
*/
/*
This module contains the modified Downhill Simplex In Multidimensions function
minimization method.
*/

/*
Useful constants.
*/

#define REFLECTCOEFF (-1.0)/*reflection coefficient*/
#define EXPANDCOEFF 2.0/*expansion coefficient*/
#define CONTRACTCOEFF 0.5/*contraction coefficient*/
#define MAXITER 10000/*max number of iterations of convergence algorithm*/

/*
Functions used.
*/

void DownhillSimplex();
void Extrapolate();
void ContractTowardLow();
void FindCentroid();
void OrderSimplex();
double FindError();
void InitSimplex();
extern double ObjectiveFunction();
